## ecflow 4.15.0

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_CXX_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
##############################################################################

# Need cmake(3.12.0) for boost python3 libs to be found.
cmake_minimum_required( VERSION 2.12.0 FATAL_ERROR )

# ===========================================================================
# Change the default if NO CMAKE_BUILD_TYPE specified
if (NOT DEFINED CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release CACHE STRING "Build Configuration type" FORCE)
endif()


project( ecflow CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
# ecbuild_info( "CMAKE_MODULE_PATH    : ${CMAKE_MODULE_PATH}")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.6 )


###############################################################################
# local project

ecbuild_declare_project()

# =========================================================================================
# VERSION  
# Get the ecflow version specified in 'VERSION.cmake'. This is only accessible after ecbuild_declare_project()
# The ecflow version config is done in ACore directory
# =========================================================================================

ecbuild_info( "CMAKE_INSTALL_PREFIX     : ${CMAKE_INSTALL_PREFIX}" )
ecbuild_info( "ECFLOW_RELEASE           : ${ECFLOW_RELEASE}" )
ecbuild_info( "ECFLOW_MAJOR             : ${ECFLOW_MAJOR}" )
ecbuild_info( "ECFLOW_MINOR             : ${ECFLOW_MINOR}" )
ecbuild_info( "ECFLOW_VERSION           : ${ECFLOW_VERSION_STR}" )

# =========================================================================================
# Options , be aware of caching, when modifying on the command line. 
# Ideally start fresh or remove cache CmakeCache.txt in build dir
# =========================================================================================
option( ENABLE_SERVER              "Build the server, can be switched off if just building UI" ON  )
option( ENABLE_PYTHON              "enable python interface"         ON  )
option( ENABLE_UI                  "Build ecFlowUI"                  ON  ) 
option( ENABLE_GUI                 "Build ecflowview"                ON  )
option( ENABLE_STATIC_BOOST_LIBS   "Link with boost libs statically" ON  )
option( ENABLE_ALL_TESTS           "This includes performance/migration/regression tests" OFF )
option( ENABLE_UI_BACKTRACE        "Print a UI debug backtrace"         OFF ) 
option( ENABLE_UI_USAGE_LOG        "Enable UI usage logging"            OFF )
option( ENABLE_SSL                 "Enable SSL encrypted communication" OFF )
option( ENABLE_SECURE_USER         "Enable passwords for user"          OFF )
option( ENABLE_PYTHON_PTR_REGISTER "Some compilers/boost versions do not register shared ptr automatically" OFF  )

# =========================================================================================
# Qt for ecFlowUI. 
# Algorithm: we test for Qt5 - if it's there, then use it; otherwise look for Qt4.
#            if we don't find that, then we cannot build ecFlowUI.
# =========================================================================================
if(ENABLE_UI)

    ecbuild_info("")
    ecbuild_info("------------------------------ Qt start ---------------------------")
    ecbuild_info("ecFlowUI is enabled - searching for Qt5; if not found, will try Qt4")
    ecbuild_info("To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH")

    find_package(Qt5Widgets 5.0.0)
    if (Qt5Widgets_FOUND)
        find_package(Qt5Gui 5.0.0)
        if (Qt5Gui_FOUND)
            find_package(Qt5Network 5.0.0)
            if (Qt5Network_FOUND)
                find_package(Qt5Svg 5.0.0)
                if (Qt5Svg_FOUND)
                    find_package(Qt5Charts 5.0.0)
                endif()
            endif()
        endif()
    endif()

    if (Qt5Widgets_FOUND AND Qt5Gui_FOUND AND Qt5Network_FOUND AND Qt5Svg_FOUND)
          ecbuild_info("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
          set(ECFLOW_QT_INCLUDE_DIR ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
          set(ECFLOW_QT_LIBRARIES   ${Qt5Widgets_LIBRARIES}    ${Qt5Gui_LIBRARIES}   ${Qt5Network_LIBRARIES} ${Qt5Svg_LIBRARIES})
          set(ECFLOW_QT5 1)
          add_definitions(-DECFLOW_QT5)

          if(Qt5Charts_FOUND)
              ecbuild_info("Qt5Charts was found - the server log viewer will be built")
              list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt5Charts_INCLUDE_DIRS})
              list(APPEND ECFLOW_QT_LIBRARIES  ${Qt5Charts_LIBRARIES})
              set(ECFLOW_LOGVIEW 1)
              add_definitions(-DECFLOW_LOGVIEW)
          else()
              ecbuild_info("Qt5Charts was not found - the server log viewer will not be built")
          endif()

    else()
        ecbuild_info("Could not find all required Qt5 packages (Qt5Widgets, Qt5Gui and Qt5Network) - searching for Qt4")
        ecbuild_info(" ** To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH **")

        find_package(Qt4 4.8.0 REQUIRED QtCore QtGui QtNetwork QtSvg)
        if(QT_FOUND)
            ecbuild_info("Found Qt 4, please ignore any warnings about Qt5 components that were not found.")
        else()
            ecbuild_info(" ** To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH **")
            ecbuild_critical("Qt5 and Qt4 not found - one of these is required for ecFlowUI; or use -DENABLE_UI=OFF")
        endif()
    endif()

    set(ECFLOW_QT 1)
    add_definitions(-DQT_NO_KEYWORDS) # We need to disable keywords because there is a problem in using Qt and boost together.
    ecbuild_info("------------------------------ Qt end----------------------------")
    ecbuild_info("")

endif()


# sanity check - cannot set ENABLE_UI_BACKTRACE if UI is OFF
if(ENABLE_UI_BACKTRACE AND (NOT ENABLE_UI))
	ecbuild_warn("Cannot ENABLE_UI_BACKTRACE if UI is not enabled")
    set(ENABLE_UI_BACKTRACE OFF)
endif()

# sanity check - cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI and ENABLE_UI_BACKTRACE are OFF
if(UI_BACKTRACE_EMAIL_ADDRESS_FILE AND (NOT ENABLE_UI))
	ecbuild_warn("Cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI is not enabled")
    set(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
endif()

# sanity check - cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is OFF
if(UI_LOG_FILE AND (NOT ENABLE_UI_USAGE_LOG))
	ecbuild_warn("Cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is not enabled")
	set(UI_LOG_FILE)
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_FILE))
	ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT LOGUI_LOG_FILE))
    ecbuild_error("If ENABLE_UI_USAGE_LOG is set, LOGUI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_SITE_TAG
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_SITE_TAG))
	ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_SITE_TAG must also be set")
endif()


ecbuild_info( "ENABLE_SERVER              : ${ENABLE_SERVER}" )
ecbuild_info( "ENABLE_PYTHON              : ${ENABLE_PYTHON}" )
ecbuild_info( "ENABLE_PYTHON_PTR_REGISTER : ${ENABLE_PYTHON_PTR_REGISTER}" )
ecbuild_info( "ENABLE_GUI                 : ${ENABLE_GUI}" )
ecbuild_info( "ENABLE_UI                  : ${ENABLE_UI}" )
ecbuild_info( "ENABLE_ALL_TESTS           : ${ENABLE_ALL_TESTS}" )
ecbuild_info( "ENABLE_STATIC_BOOST_LIBS   : ${ENABLE_STATIC_BOOST_LIBS}" )
ecbuild_info( "ENABLE_SSL                 : ${ENABLE_SSL}" )
ecbuild_info( "ENABLE_SECURE_USER         : ${ENABLE_SECURE_USER}" )


if (ENABLE_UI)
	ecbuild_info( "ENABLE_UI_BACKTRACE      : ${ENABLE_UI_BACKTRACE}" )
	if(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
		ecbuild_info( "UI_BACKTRACE_EMAIL_ADDRESS_FILE : ${UI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
	endif()

    if(LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE)
        ecbuild_info( "LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE : ${LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
    endif()

	ecbuild_info( "ENABLE_UI_USAGE_LOG      : ${ENABLE_UI_USAGE_LOG}" )
	if(ENABLE_UI_USAGE_LOG)
		ecbuild_info( "UI_LOG_FILE              : ${UI_LOG_FILE}" )
        ecbuild_info( "LOGUI_LOG_FILE           : ${LOGUI_LOG_FILE}" )
        ecbuild_info( "UI_LOG_SITE_TAG          : ${UI_LOG_SITE_TAG}" )
	endif()
endif()
ecbuild_info("")

# ======================================================================================
# GUI requires X11 and Motif
# ======================================================================================

if(ENABLE_GUI)
  find_package( X11 )
#  if ( X11_FOUND )
#	   ecbuild_debug_var( X11_INCLUDE_DIR )
#	   ecbuild_debug_var( X11_LIBRARIES )  
#	   ecbuild_debug_var( X11_Xt_INCLUDE_PATH )
#	   ecbuild_debug_var( X11_Xt_LIB )
#	   ecbuild_debug_var( X11_Xpm_INCLUDE_PATH )
#	   ecbuild_debug_var( X11_Xpm_LIB )
#  endif()

  find_package( Motif )
#  if ( MOTIF_FOUND )
#	   ecbuild_debug_var( MOTIF_INCLUDE_DIR )
#	   ecbuild_debug_var( MOTIF_LIBRARIES )  
#  endif()
endif()
 

# =========================================================================================
# Boost
# =========================================================================================

# this can help in some situations:
set (_CMAKE_PREFIX_PATH_BACKUP ${CMAKE_PREFIX_PATH}) # make a backup of CMAKE_PREFIX_PATH
foreach(BOOST_PATH_TO_SEARCH ${BOOST_PATH} ${BOOST_ROOT} $ENV{BOOST_ROOT})
    ecbuild_debug("adding: ${BOOST_PATH_TO_SEARCH} to CMAKE_PREFIX_PATH")
    list(APPEND CMAKE_PREFIX_PATH ${BOOST_PATH_TO_SEARCH})
    list(REMOVE_DUPLICATES CMAKE_PREFIX_PATH)
endforeach()


# Ecflow test require statics libs for boost < 1.59, otherwise get double free error.
# To use static boost python ensure that Boost_USE_STATIC_LIBS is set on.
# See: http://www.cmake.org/cmake/help/v3.0/module/FindBoost.html
if ( ENABLE_STATIC_BOOST_LIBS )
    set(Boost_USE_STATIC_LIBS ON)
endif()
set(Boost_USE_MULTITHREADED      ON)
set(Boost_NO_SYSTEM_PATHS        ON)
set(Boost_DETAILED_FAILURE_MSG   ON)
#set(Boost_DEBUG                 ON)

set(ECFLOW_BOOST_VERSION "1.53.0")
find_package( Boost ${ECFLOW_BOOST_VERSION} REQUIRED COMPONENTS serialization system thread unit_test_framework test_exec_monitor filesystem program_options date_time regex)

#ecbuild_info( "Boost_LIBRARIES     : ${Boost_LIBRARIES}" )

if (NOT "${CMAKE_PREFIX_PATH}" EQUAL "${_CMAKE_PREFIX_PATH_BACKUP}")
    set (CMAKE_PREFIX_PATH ${_CMAKE_PREFIX_PATH_BACKUP}) # restore CMAKE_PREFIX_PATH
    ecbuild_debug("Resetting CMAKE_PREFIX_PATH to ${CMAKE_PREFIX_PATH}")
endif()

# =======================================================================
# SSL
# =======================================================================
if (ENABLE_SSL)
    find_package(OpenSSL REQUIRED)
    if (NOT OPENSSL_FOUND )
        ecbuild_error("Can not find openssl libraries")
    endif() 
    include_directories( ${OPENSSL_INCLUDE_DIR} )
    add_definitions( -DECF_OPENSSL )
endif()

# =======================================================================
# SECURE_USER
# =======================================================================
if (ENABLE_SECURE_USER)
    add_definitions( -DECF_SECURE_USER )
endif()


# =========================================================================================
# debug
# =========================================================================================

=== ACore/CMakeLists.txt ===
# Note:
# If new src or test is added make sure you touch this file
#

# Only really needed for File.cpp
add_definitions( -DCMAKE )

# We place generated file in /ACore/src/ so that we can still use boost build
configure_file( ecflow_version.h.in ${CMAKE_SOURCE_DIR}/ACore/src/ecflow_version.h )

# place in binary directory since this is different for each user
configure_file( ecflow_source_build_dir.h.in ${CMAKE_BINARY_DIR}/ecflow_source_build_dir.h )
		
# Use transitive nature: i.e if any lib/exe uses lib core, they
# will also inherit the boost libs.
#
file( GLOB srcs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "src/*.cpp" )
ecbuild_add_library( TARGET core
                     NOINSTALL
                     TYPE     STATIC
                     SOURCES  ${srcs}
                     INCLUDES src
                              ${Boost_INCLUDE_DIRS}
                              ${CMAKE_BINARY_DIR} 
                    )

# This ensures that for debug config, we only link with debug boost libs, for other configs, we link with optimised boost libs
target_link_libraries(core debug ${Boost_SERIALIZATION_LIBRARY_DEBUG}   ${Boost_SERIALIZATION_LIBRARY_RELEASE}
                           debug ${Boost_FILESYSTEM_LIBRARY_DEBUG}      ${Boost_FILESYSTEM_LIBRARY_RELEASE}
                           debug ${Boost_DATE_TIME_LIBRARY_DEBUG}       ${Boost_DATE_TIME_LIBRARY_RELEASE}
                           debug ${Boost_SYSTEM_LIBRARY_DEBUG}          ${Boost_SYSTEM_LIBRARY_RELEASE}
                           )                
                   
file( GLOB test_srcs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "test/*.cpp" )
ecbuild_add_test( TARGET   u_acore 
                  SOURCES  ${test_srcs}
                  INCLUDES ${Boost_INCLUDE_DIRS}
                  LIBS     core ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_TEST_EXEC_MONITOR_LIBRARY}
                )

=== Base/CMakeLists.txt ===
 # =======================================================
 # to list all sources to build use:
 #    cd $WK/Base
 #    find src -name \*.cpp >> CMakeLists.txt
 # =======================================================
 list( APPEND srcs
 src/ZombieCtrl.cpp
 src/Stats.cpp
 src/Client.cpp
 src/ServerReply.cpp
 src/Connection.cpp
 src/stc/DefsCache.cpp
 src/stc/DefsCmd.cpp
 src/stc/PreAllocatedReply.cpp
 src/stc/SStringVecCmd.cpp
 src/stc/StcCmd.cpp
 src/stc/SSuitesCmd.cpp
 src/stc/SClientHandleCmd.cpp
 src/stc/SStringCmd.cpp
 src/stc/ServerToClientCmd.cpp
 src/stc/SClientHandleSuitesCmd.cpp
 src/stc/SServerLoadCmd.cpp
 src/stc/SNodeCmd.cpp
 src/stc/SStatsCmd.cpp
 src/stc/SSyncCmd.cpp
 src/stc/SNewsCmd.cpp
 src/stc/ErrorCmd.cpp
 src/stc/GroupSTCCmd.cpp
 src/stc/ZombieGetCmd.cpp
 src/ClientToServerRequest.cpp
 src/Gnuplot.cpp
 src/WhyCmd.cpp
 src/ServerToClientResponse.cpp
 src/cts/CSyncCmd.cpp
 src/cts/ZombieCmd.cpp
 src/cts/OrderNodeCmd.cpp
 src/cts/CheckPtCmd.cpp
 src/cts/CtsNodeCmd.cpp
 src/cts/GroupCTSCmd.cpp
 src/cts/UserCmd.cpp
 src/cts/ClientHandleCmd.cpp
 src/cts/PlugCmd.cpp
 src/cts/ForceCmd.cpp
 src/cts/LoadDefsCmd.cpp
 src/cts/CFileCmd.cpp
 src/cts/ShowCmd.cpp
 src/cts/CtsCmd.cpp
 src/cts/TaskApi.cpp
 src/cts/EditScriptCmd.cpp
 src/cts/FreeDepCmd.cpp
 src/cts/PathsCmd.cpp
 src/cts/EditHistoryMgr.cpp
 src/cts/LogMessageCmd.cpp
 src/cts/CtsApi.cpp
 src/cts/ReplaceNodeCmd.cpp
 src/cts/RequeueNodeCmd.cpp
 src/cts/BeginCmd.cpp
 src/cts/LogCmd.cpp
 src/cts/AlterCmd.cpp
 src/cts/TaskCmds.cpp
 src/cts/CtsCmdRegistry.cpp
 src/cts/RunNodeCmd.cpp
 src/cts/ClientToServerCmd.cpp
 src/cts/ServerVersionCmd.cpp
)

if(OPENSSL_FOUND)
  list( APPEND srcs src/Openssl.cpp )
endif()

ecbuild_add_library( TARGET   base
                     NOINSTALL
                     TYPE     STATIC
                     SOURCES  ${srcs}
                     LIBS     node nodeattr core
                     INCLUDES src
                              ../ACore/src
                              ../ANattr/src
                              ../ANode/src
                              ../Base/src
                              ../Base/src/cts
                              ../Base/src/stc
                     )

# This ensures that for debug config, we only link with debug boost libs, for other configs, we link with optimised boost libs
target_link_libraries(base debug ${Boost_PROGRAM_OPTIONS_LIBRARY_DEBUG}   ${Boost_PROGRAM_OPTIONS_LIBRARY_RELEASE})

list( APPEND test_srcs
   test/TestAlterCmd.cpp
   test/TestClientHandleCmd.cpp
   test/TestCmd.cpp
   test/TestDeleteNodeCmd.cpp
   test/TestECFLOW-189.cpp
   test/TestForceCmd.cpp
   test/TestFreeDepCmd.cpp
   test/TestLimit.cpp
   test/TestLoadDefsCmd.cpp
   test/TestLogCmd.cpp
   test/TestMeterCmd.cpp
   test/TestProgramOptions.cpp
   test/TestRequest.cpp
   test/TestRequeueNodeCmd.cpp
   test/TestResolveDependencies.cpp
   test/TestSSyncCmd_CH1.cpp
   test/TestSSyncCmd.cpp
   test/TestSSyncCmdOrder.cpp
)

# if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty
ecbuild_add_test( TARGET       u_base
                  SOURCES      ${test_srcs}
                  LIBS         base pthread ${OPENSSL_LIBRARIES}
                               ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_TEST_EXEC_MONITOR_LIBRARY}
                  INCLUDES     ../ANode/test ${Boost_INCLUDE_DIRS}
                  TEST_DEPENDS u_aparser
                  )

=== Pyext/CMakeLists.txt ===
### ecflow python bindings
# NOTES:
#
# To see the python link line: Do python-config  --ldflags, i.e
#   > /usr/local/apps/python/2.7.8-01/bin/python-config  --ldflags
#   > -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# However on cct we get:
#   > /usr/local/apps/python/2.7.5-01/bin/python-config --ldflags
#   > -L/usr/local/apps/python/2.7.5-01/lib/python2.7/config -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# cct is correct as it has the "-L" but on other machines we rely on /usr/lib/libpython2.7.so.1.0 being there!
# lxop-test does not have /usr/lib/libpython2.7.so.1.0 so ecbuild fails
#
# For problems with the python build, please look in <build-dir>/ecbuild.log, typically non developmental python
# installs may not include python libs or includes
# For ubuntoo to install we need:
#    sudo apt-get install libpython-dev
#

# =============================================================================
# Configure __init__.py to add __version__
# =============================================================================
set(INIT_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py.in")
set(INIT_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py")
configure_file(${INIT_PY_IN} ${INIT_PY_OUT} )


# ==============================================================================
# local includes
# ==============================================================================
include_directories(  
                     ../ACore/src 
                     ../ANattr/src
                     ../ANode/src
                     ../Base/src
                     ../Base/src/cts
                     ../Base/src/stc
                     ../Client/src
                     ../CSim/src
                    )

message( STATUS "====================================================================================================================" )
message( STATUS "PYTHON2" )
message( STATUS "====================================================================================================================" )
if(${CMAKE_VERSION} VERSION_LESS "3.12.0") 
	# We only support python2 extension for cmake less 3.12.0
	# cmake 3.12.0 or greater allows multiple boost python libs & hence multiple extensions to be built
	# Using -DPYTHON_EXECUTABLE=/usr/local/apps/python3/3.6.5-01/bin/python3 is not suffcient as the wrong(python2) libs are found
	ecbuild_find_python( VERSION 2.6 REQUIRED )  
	message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
    message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
    message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
    message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
    message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
    message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
    message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
    message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
    message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
    message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
    message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )
	if (${PYTHON_VERSION_MAJOR} EQUAL 3)
		ecbuild_error("Need cmake version >= 3.12.0 to build ecflow python3 extension, current cmake version is ${CMAKE_VERSION}")
	endif()
	find_package( Boost ${ECFLOW_BOOST_VERSION} REQUIRED COMPONENTS python )
	add_subdirectory( python2 )
else()
	# ======================================================================================
	# Attempt to build both python2 *AND/OR* python3 ecflow extension, depending on what is found
	# this assumes cmake 3.12.0 min, which added support for boost python2 and python3
	# * NOTICE* that we do *NOT* use REQUIRED when searching for boost python libs
	# ======================================================================================
	find_package(Python2 COMPONENTS Interpreter Development)
	if (Python2_FOUND)
		message( STATUS "  Python2_Interpreter_FOUND         : ${Python2_Interpreter_FOUND}" )
		message( STATUS "  Python2_EXECUTABLE                : ${Python2_EXECUTABLE}" )
		message( STATUS "  Python2_STDLIB                    : ${Python2_STDLIB}    Standard platform independent installation directory" )
		message( STATUS "  Python2_STDARCH                   : ${Python2_STDARCH}   Standard platform dependent installation directory." )
		message( STATUS "  Python2_Development_FOUND         : ${Python2_Development_FOUND}" )
	    message( STATUS "  Python2_INCLUDE_DIRS              : ${Python2_INCLUDE_DIRS}" )
		message( STATUS "  Python2_LIBRARIES                 : ${Python2_LIBRARIES}" )
	    message( STATUS "  Python2_LIBRARY_DIRS              : ${Python2_LIBRARY_DIRS}" )
		message( STATUS "  Python2_VERSION                   : ${Python2_VERSION}" )
		message( STATUS "  Python2_VERSION_MAJOR             : ${Python2_VERSION_MAJOR}" )
		message( STATUS "  Python2_VERSION_MINOR             : ${Python2_VERSION_MINOR}" )
		message( STATUS "  Python2_VERSION_PATCH             : ${Python2_VERSION_PATCH}" )
	    # *****************************************************************************************
	    # Although we have found python2 it could be that *ONLY* python3 was module loaded
	    # Otherwise will build for python2 and test with python3 interpreter
	    # *****************************************************************************************
	    if ( Python2_LIBRARIES )             
	    	ecbuild_find_python( VERSION 2.6 REQUIRED ) # if not included iterpreter not found ?
	    	if ( ${PYTHON_VERSION_MAJOR} EQUAL 2)
		    	message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
		    	message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
		   		message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
		    	message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
		    	message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
		    	message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
		    	message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
		    	message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
		    	message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
		    	message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
		    	message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )
		    	
	    		if ( Boost_MINOR_VERSION GREATER 66 )
	       			find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR} )
				else()
	   				find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python )
				endif()
		
	    	    if (Boost_PYTHON_FOUND OR Boost_PYTHON${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR}_FOUND) 
					set(ECF_PYTHON_FOUND "ECF_PYTHON_FOUND")
					add_subdirectory( python2 )
				else()
					message( STATUS "  Boost python2 libraries *NOT* found" )
				endif()
			endif()
		else()
		    message( STATUS "  Python2 libraries *NOT* found" )
		endif()
	endif()

	message( STATUS "====================================================================================================================" )
	message( STATUS "PYTHON3" )
	message( STATUS "====================================================================================================================" )
	find_package(Python3 COMPONENTS Interpreter Development)
	if (Python3_FOUND)
		message( STATUS "  Python3_Interpreter_FOUND         : ${Python3_Interpreter_FOUND}" )
		message( STATUS "  Python3_EXECUTABLE                : ${Python3_EXECUTABLE}" )
		message( STATUS "  Python3_STDLIB                    : ${Python3_STDLIB}    Standard platform independent installation directory" )
		message( STATUS "  Python3_STDARCH                   : ${Python3_STDARCH}   Standard platform dependent installation directory." )
		message( STATUS "  Python3_Development_FOUND         : ${Python3_Development_FOUND}" )
		message( STATUS "  Python3_INCLUDE_DIRS              : ${Python3_INCLUDE_DIRS}" )
		message( STATUS "  Python3_LIBRARIES                 : ${Python3_LIBRARIES}" )
		message( STATUS "  Python3_LIBRARY_DIRS              : ${Python3_LIBRARY_DIRS}" )
		message( STATUS "  Python3_VERSION                   : ${Python3_VERSION}" )
		message( STATUS "  Python3_VERSION_MAJOR             : ${Python3_VERSION_MAJOR}" )
		message( STATUS "  Python3_VERSION_MINOR             : ${Python3_VERSION_MINOR}" )
		message( STATUS "  Python3_VERSION_PATCH             : ${Python3_VERSION_PATCH}" )
		
	    if ( Boost_MINOR_VERSION GREATER 66 )
	       	find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python${Python3_VERSION_MAJOR}${Python3_VERSION_MINOR} )
		else()
	   		find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python3 )
		endif()
		
	    if (Boost_PYTHON3_FOUND OR Boost_PYTHON${Python3_VERSION_MAJOR}${Python3_VERSION_MINOR}_FOUND)
	 	    if ( Python3_LIBRARIES )             
	    		ecbuild_find_python( VERSION ${Python3_VERSION} REQUIRED )
				set(ECF_PYTHON_FOUND "ECF_PYTHON_FOUND")
				add_subdirectory( python3 )
			else()
				message( STATUS "  python3 libraries *NOT* found" )
			endif()
		else()
			message( STATUS "  Boost python3 libraries *NOT* found" )
		endif()
	endif()
	
	if (NOT ECF_PYTHON_FOUND)
		ecbuild_error("ecflow python extension is enabled, but python2/python3 libraries or python boost libraries not found")
	endif()
endif()
message( STATUS "====================================================================================================================" )
message( STATUS "END PYTHON" )
message( STATUS "====================================================================================================================" )

=== Server/CMakeLists.txt ===
 # =======================================================
 # LIB
 # to list all sources to build use:
 #    cd $WK/Server
 #    find src -name \*.cpp  -print | sort
 # =======================================================
list( APPEND srcs
   src/CConnection.cpp
   src/CheckPtSaver.cpp
   src/NodeTreeTraverser.cpp
   src/Server.cpp
   src/ServerEnvironment.cpp
   src/ServerOptions.cpp
)
ecbuild_add_library( TARGET libserver
                     NOINSTALL
                     TYPE     STATIC
                     SOURCES  ${srcs}
                     LIBS     base node nodeattr core
                              pthread
                     INCLUDES src
                              ../ACore/src 
                              ../ANattr/src
                              ../ANode/src
                              ../Base/src
                              ../Base/src/cts
                              ../Base/src/stc
                     )

# This ensures that for debug config, we only link with debug boost libs, for other configs, we link with optimised boost libs
target_link_libraries(libserver debug ${Boost_THREAD_LIBRARY_DEBUG} ${Boost_THREAD_LIBRARY_RELEASE})

# =======================================================
# EXE ecflow_server, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable( TARGET   ecflow_server
                        SOURCES  src/ServerMain.cpp
                        LIBS     libserver ${OPENSSL_LIBRARIES}
                        INCLUDES ${Boost_INCLUDE_DIRS} 
                       )

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_server PROPERTIES 
                                    INSTALL_RPATH ""
                     )
                         
# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

                          
# ================================================================================                         
# TEST
ecbuild_add_test( TARGET       u_server
                  SOURCES      test/TestServerEnvironment.cpp 
                               test/TestServer1.cpp
                  INCLUDES     ${Boost_INCLUDE_DIRS}
                  LIBS         libserver ${OPENSSL_LIBRARIES}
                               ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_TEST_EXEC_MONITOR_LIBRARY}
                  TEST_DEPENDS u_base
              )

# ===================================================================
# install
# ===================================================================
install (TARGETS ecflow_server DESTINATION bin)

=== Test/CMakeLists.txt ===
# =======================================================
# to list all sources to build use:
#    cd $WK/Test
#    find src -name \*.cpp -print | sort
# =======================================================
file( GLOB srcs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "src/*.cpp" )
 
# This library is used for the syste, level testing, hence can include test directories
ecbuild_add_library( TARGET   libharness
                     NOINSTALL
                     TYPE     STATIC
                     SOURCES  ${srcs}
                     LIBS     libclient base node nodeattr core  
                     INCLUDES src
                              ../ACore/src 
                              ../ANattr/src
                              ../ANode/src
                              ../ANode/test
                              ../Base/src
                              ../Base/src/cts
                              ../Base/src/stc
                              ../Base/test
                              ../Client/src
                              ../Client/test
                    )

# =================================================================
# test

if (ENABLE_ALL_TESTS)

	list( APPEND test_srcs
	./TestAbortCmd.cpp
	./TestAlias.cpp
	./TestClkSync.cpp
	./TestComplete.cpp
	./TestCron.cpp
	./TestCtsWaitCmd.cpp
	./TestEvents.cpp
	./TestFileCmd.cpp
	./TestHandle.cpp
	./TestKillCmd.cpp
	./TestLate.cpp
	./TestLimit.cpp
	./TestOrderCmd.cpp
	./TestRepeat.cpp
	./TestRequeueNode.cpp
	./TestRunner.cpp
	./TestServer.cpp
	./TestSuspend.cpp
	./TestToday.cpp
	./TestTrigger.cpp
	./TestWhyCmd.cpp
	./Test_Time.cpp
	)
	
	# if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty
	ecbuild_add_test( TARGET s_test
	                  SOURCES  ${test_srcs}
	                  INCLUDES ${Boost_INCLUDE_DIRS}
	                  LIBS     libharness ${OPENSSL_LIBRARIES}
	                           ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_TEST_EXEC_MONITOR_LIBRARY}
	                  TEST_DEPENDS s_client
	                )
	
	ecbuild_add_test( TARGET  s_test_zombies
	                  SOURCES   ./TestZombies.cpp
	                  INCLUDES  ${Boost_INCLUDE_DIRS}
	                  LIBS      libharness ${OPENSSL_LIBRARIES}
	                            ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_TEST_EXEC_MONITOR_LIBRARY}
	                  TEST_DEPENDS s_test
	                )
	
	# This test runs forever, hence not suitable for unit test.                          
	#ecbuild_add_test( TARGET  singletest
	#                  SOURCES   ./TestSingle.cpp
	#                  INCLUDES  ${Boost_INCLUDE_DIRS}
	#                  LIBS      libharness 
	#                            ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_TEST_EXEC_MONITOR_LIBRARY}
	#                  TEST_DEPENDS s_client
	#               )
endif()

=== Viewer/ecflowUI/src/CMakeLists.txt ===

set(viewer_srcs   
    ViewerMain.cpp
    AboutDialog.cpp
    AbstractNodeModel.cpp
    AbstractNodeView.cpp
    AbstractSearchLine.cpp
    AbstractTextEditSearchInterface.cpp
    ActionHandler.cpp
    AddLabelDialog.cpp
    AddModelColumnDialog.cpp
    Animation.cpp
    AstCollateVNodesVisitor.cpp
    AttributeEditor.cpp
    AttributeEditorFactory.cpp   
    CaseSensitiveButton.cpp
    ChangeNotify.cpp
    ChangeNotifyDialog.cpp
    ChangeNotifyEditor.cpp
    ChangeNotifyModel.cpp
    ChangeNotifyWidget.cpp
    ClockWidget.cpp
    CodeItemWidget.cpp
    ComboMulti.cpp
    CommandDesignerWidget.cpp
    CommandHandler.cpp
    CommandOutput.cpp
    CommandOutputDialog.cpp
    CommandOutputWidget.cpp
    CompactView.cpp
    ConfigListDelegate.cpp
    ConnectState.cpp
    CustomCommandDialog.cpp
    CustomCommandHandler.cpp
    CustomListWidget.cpp
    CustomTabWidget.cpp
    Dashboard.cpp
    DashboardDialog.cpp
    DashboardDock.cpp
    DashboardTitle.cpp
    DashboardWidget.cpp
    DiagData.cpp
    EditItemWidget.cpp
    EditProvider.cpp
    EditorInfoLabel.cpp
    EventEditor.cpp
    ExpandState.cpp
    ExpandStateNode.cpp
    FlagSet.hpp
    FileInfoLabel.cpp
    FileWatcher.cpp
    FilterWidget.cpp
    FontMetrics.cpp
    GotoLineDialog.cpp
    Highlighter.cpp
    HistoryItemWidget.cpp
    HtmlEdit.cpp
    HtmlItemWidget.cpp
    InfoPanel.cpp 
    InfoPanelItem.cpp   
    InfoPanelHandler.cpp
    InfoProvider.cpp
    InputEventLog.cpp
    JobItemWidget.cpp
    LabelEditor.cpp
    LimitEditor.cpp
    LineEdit.cpp  
    LogProvider.cpp     
    LogViewerCom.cpp
    MainWindow.cpp
    ManualItemWidget.cpp 
    MenuConfigDialog.cpp
    MenuHandler.cpp
    MessageItemWidget.cpp
    MeterEditor.cpp
    ModelColumn.cpp
    NodeExpression.cpp
    NodeFilterDialog.cpp    
    NodePanel.cpp
    NodePathWidget.cpp
    NodeQuery.cpp
    NodeQueryCombo.cpp
    NodeQueryEditor.cpp
    NodeQueryEngine.cpp
    NodeQueryHandler.cpp
    NodeQueryOption.cpp
    NodeQueryOptionEdit.cpp
    NodeQueryResult.cpp
    NodeQueryResultModel.cpp
    NodeQueryResultView.cpp
    NodeQueryViewDelegate.cpp
    NodeSearchDialog.cpp
    NodeSearchWidget.cpp
    NodeViewBase.cpp
    NodeViewDelegate.cpp
    NodeWidget.cpp
    OneLineTextEdit.cpp
    OutputBrowser.cpp
    OutputCache.cpp
    OutputClient.cpp
    OutputFetchInfo.cpp
    OutputFileClient.cpp
    OutputDirClient.cpp
    OutputModel.cpp
    OutputItemWidget.cpp
    OutputFileProvider.cpp
    OutputDirProvider.cpp
    OverviewItemWidget.cpp
    OverviewProvider.cpp
    PlainTextEdit.cpp
    PlainTextSearchLine.cpp
    PlainTextSearchInterface.cpp
    PropertyDialog.cpp
    PropertyEditor.cpp
    PropertyLine.cpp
    PropertyMapper.cpp
    RectMetrics.cpp
    RepeatEditor.cpp
    RichTextEdit.cpp
    RichTextSearchInterface.cpp
    RichTextSearchLine.cpp
    SaveSessionAsDialog.cpp
    ScriptItemWidget.cpp
    ServerComInfoWidget.cpp
    ServerComQueue.cpp
    ServerComThread.cpp
    ServerDefsAccess.cpp
    ServerHandler.cpp
    ServerFilter.cpp
    ServerItem.cpp
    ServerList.cpp
    ServerListDialog.cpp
    ServerListSyncWidget.cpp   
    ServerLoadItemWidget.cpp
    ServerSettingsItemWidget.cpp
    SessionDialog.cpp
    SessionRenameDialog.cpp
    SessionHandler.cpp
    ShellCommand.cpp
    Sound.cpp
    StandardView.cpp
    StringMatchCombo.cpp
    StringMatchMode.cpp
    SuiteItemWidget.cpp
    SuiteFilter.cpp
    SuiteFilterObserver.hpp
    SuiteModel.cpp
    TabWidget.cpp 
    TableFilterWidget.cpp
    TableNodeModel.cpp
    TableNodeSortModel.cpp
    TableNodeView.cpp
    TableNodeViewDelegate.cpp
    TableNodeWidget.cpp
    TextEditSearchLine.cpp
    TextFilterHandler.cpp
    TextFilterHandlerDialog.cpp
    TextFilterWidget.cpp   
    TimelineHeaderView.cpp
    TimelineInfoDailyView.cpp
    TimelineInfoDailyWidget.cpp
    TimelineInfoDelegate.cpp
    TimelineInfoWidget.cpp
    TimelineItemWidget.cpp
    TimelineData.cpp
    TimelineFileList.cpp
    TimelineModel.cpp
    TimelinePreLoadDialog.cpp
    TimelineView.cpp
    TimelineWidget.cpp
    TreeNodeModel.cpp
    TreeNodeView.cpp
    TreeNodeViewDelegate.cpp
    TreeNodeWidget.cpp
    TreeView.cpp
    TriggerEditor.cpp   
    TriggerItemWidget.cpp
    TriggerTextWidget.cpp    
    TriggerCollector.cpp
    TriggerTableModel.cpp
    TriggerTableView.cpp
    TriggerTableWidget.cpp
    TriggerViewDelegate.cpp
    TriggeredScanner.cpp    
    UiLogS.cpp
    UpdateTimer.cpp
    VAttribute.cpp
    VAttributeType.cpp
    VConfig.cpp
    VConfigLoader.cpp
    VDateAttr.cpp
    VDir.cpp
    VEventAttr.cpp
    VFilter.cpp
    VIcon.cpp
    VInfo.cpp
    VFile.cpp
    VFileInfo.cpp
    VFileTransfer.cpp
    VItem.cpp
    VItemPathParser.cpp
    VLabelAttr.cpp
    VLateAttr.cpp
    VLimitAttr.cpp
    VLimiterAttr.cpp
    VMeterAttr.cpp
    VModelData.cpp
    VNode.cpp
    VNodeList.cpp
    VNodeMover.cpp
    VNodeStateDiag.cpp
    VNState.cpp
    VParam.cpp
    VProperty.cpp
    VRepeatAttr.cpp
    VReply.cpp
    VReportMaker.cpp
    VServerSettings.cpp
    VSettings.cpp
    VSettingsLoader.cpp
    VSState.cpp
    VTask.cpp
    VTaskNode.cpp
    VTimeAttr.cpp
    VTree.cpp
    VTriggerAttr.cpp
    VGenVarAttr.cpp
    VUserVarAttr.cpp
    VariableEditor.cpp
    VariableModel.cpp
    VariableModelData.cpp
    VariableItemWidget.cpp
    VariableSearchLine.cpp
    VariableView.cpp
    ViewerUtil.cpp
    WhyItemWidget.cpp
    WidgetNameProvider.cpp
    WmWorkspaceHandler.cpp
    ZombieItemWidget.cpp
    ZombieModel.cpp
    TextPager/TextPagerCursor.cpp
    TextPager/TextPagerDocument.cpp
    TextPager/TextPagerEdit.cpp
    TextPager/TextPagerLayout_p.cpp
    TextPager/TextPagerSearchHighlighter.cpp
    TextPager/TextPagerSearchInterface.cpp
    TextPager/TextPagerSection.cpp
    TextPager/TextPagerWidget.cpp
    TextPager/syntaxhighlighter.cpp)

if(ECFLOW_QT5)
    include_directories(${ECFLOW_QT_INCLUDE_DIR})
else()
    include(${QT_USE_FILE}) 
    set(ECFLOW_QT_LIBRARIES ${QT_LIBRARIES})
endif()


set(viewer_moc_files AbstractNodeModel.hpp
    AbstractNodeView.hpp
    AbstractSearchLine.hpp
    ActionHandler.hpp
    AddLabelDialog.hpp
    AddModelColumnDialog.hpp
    Animation.hpp
    AttributeEditor.hpp
    CaseSensitiveButton.hpp
    ChangeNotifyDialog.hpp
    ChangeNotifyEditor.hpp
    ChangeNotifyModel.hpp
    ChangeNotifyWidget.hpp
    ClockWidget.hpp
    CodeItemWidget.hpp
    ComboMulti.hpp
    CommandDesignerWidget.hpp    
    CommandOutput.hpp
    CommandOutputDialog.hpp
    CommandOutputWidget.hpp
    CustomCommandDialog.hpp
    CustomListWidget.hpp
    Dashboard.hpp
    DashboardDialog.hpp
    DashboardDock.hpp
    DashboardTitle.hpp
    DashboardWidget.hpp
    EditItemWidget.hpp
    EventEditor.hpp
    FileWatcher.hpp
    FilterWidget.hpp
    GotoLineDialog.hpp
    HistoryItemWidget.hpp              
    HtmlItemWidget.hpp
    InfoPanel.hpp
    InputEventLog.hpp
    LabelEditor.hpp
    LimitEditor.hpp
    LineEdit.hpp   
    LogProvider.hpp    
    MainWindow.hpp
    MenuConfigDialog.hpp
    MessageItemWidget.hpp
    MeterEditor.hpp
    ModelColumn.hpp
    NodeFilterDialog.hpp
    NodePanel.hpp
    NodePathWidget.hpp
    NodeQueryCombo.hpp           
    NodeQueryEditor.hpp
    NodeQueryOptionEdit.hpp
    NodeQueryEngine.hpp
    NodeQueryResult.hpp
    NodeQueryResultModel.hpp
    NodeQueryResultView.hpp
    NodeSearchDialog.hpp
    NodeSearchWidget.hpp
    NodeWidget.hpp
    OneLineTextEdit.hpp
    OutputBrowser.hpp
    OutputCache.hpp
    OutputClient.hpp
    OutputFileClient.hpp
    OutputDirClient.hpp
    OutputItemWidget.hpp
    OutputFileProvider.hpp
    OutputDirProvider.hpp
    PlainTextEdit.hpp
    PropertyDialog.hpp             
    PropertyEditor.hpp
    PropertyLine.hpp
    SaveSessionAsDialog.hpp
    RepeatEditor.hpp
    RichTextEdit.hpp
    ServerComInfoWidget.hpp
    ServerComQueue.hpp
    ServerComThread.hpp
    ServerHandler.hpp
    ServerListDialog.hpp
    ServerListSyncWidget.hpp
    ServerLoadItemWidget.hpp
    ServerSettingsItemWidget.hpp
    SessionDialog.hpp
    SessionRenameDialog.hpp
    ShellCommand.hpp
    StringMatchCombo.hpp
    SuiteItemWidget.hpp
    SuiteModel.hpp
    TabWidget.hpp
    TableFilterWidget.hpp
    TableNodeModel.hpp 
    TableNodeView.hpp 
    TableNodeViewDelegate.hpp
    TableNodeWidget.hpp             
    TextEditSearchLine.hpp
    TextFilterHandlerDialog.hpp
    TextFilterWidget.hpp
    TimelineData.hpp
    TimelineHeaderView.hpp
    TimelineInfoDailyView.hpp
    TimelineInfoDailyWidget.hpp
    TimelineInfoWidget.hpp
    TimelineModel.hpp
    TimelineView.hpp
    TimelineWidget.hpp
    TreeNodeModel.hpp
    TreeNodeView.hpp
    TreeNodeViewDelegate.hpp
    TreeNodeWidget.hpp    
    TriggerEditor.hpp
    TriggerItemWidget.hpp
    TriggerTableView.hpp
    TriggerTableWidget.hpp
    TriggeredScanner.hpp
    VariableEditor.hpp
    VariableItemWidget.hpp
    VariableModel.hpp
    VariableModelData.hpp
    VariableSearchLine.hpp
    VFileTransfer.hpp
    VFilter.hpp
    VModelData.hpp
    VNodeList.hpp
    WhyItemWidget.hpp
    ZombieItemWidget.hpp
    TextPager/TextPagerCursor_p.hpp
    TextPager/TextPagerDocument.hpp
    TextPager/TextPagerDocument_p.hpp
    TextPager/TextPagerEdit.hpp
    TextPager/TextPagerEdit_p.hpp
    TextPager/TextPagerSection_p.hpp
    TextPager/TextPagerWidget.hpp
    TextPager/syntaxhighlighter.hpp   
)

set(viewer_wrap_ui_files
    AboutDialog.ui
    AddLabelDialog.ui
    AddModelColumnDialog.ui
    AttributeEditorDialog.ui
    ChangeNotifyDialog.ui
    ChangeNotifyDialogWidget.ui
    ChangeNotifyEditor.ui
    CommandDesignerWidget.ui 
    CommandOutputDialog.ui
    CommandOutputWidget.ui
    CustomCommandDialog.ui
    CodeItemWidget.ui
    DashboardDialog.ui
    DashboardDockTitleWidget.ui
    EditItemWidget.ui
    EventEditorWidget.ui
    GotoLineDialog.ui
    HistoryItemWidget.ui
    HtmlItemWidget.ui
    InfoPanel.ui
    LabelEditorWidget.ui
    LimitEditorWidget.ui
    #LogLoadWidget.ui
    MainWindow.ui
    MessageItemWidget.ui
    MenuConfigDialog.ui
    MeterEditorWidget.ui
    NodeFilterDialog.ui
    NodeQueryEditor.ui
    NodeQuerySaveDialog.ui
    NodeSearchDialog.ui
    NodeSearchWidget.ui
    OutputItemWidget.ui 
    PropertyDialog.ui
    PropertyEditor.ui
    RepeatEditorWidget.ui
    SaveSessionAsDialog.ui
    SearchLineWidget.ui
    ServerAddDialog.ui
    ServerEditDialog.ui 
    ServerListDialog.ui
    ServerListSyncWidget.ui
    ServerLoadItemWidget.ui
    ServerSettingsItemWidget.ui
    SessionDialog.ui
    SessionRenameDialog.ui
    SuiteItemWidget.ui
    TableFilterWidget.ui
    TableNodeWidget.ui
    TextFilterAddDialog.ui
    TextFilterHandlerDialog.ui
    TextFilterWidget.ui
    TimelineInfoDailyWidget.ui
    TimelineInfoWidget.ui
    TimelinePreLoadDialog.ui
    TimelineWidget.ui
    TreeNodeWidget.ui
    TriggerEditorWidget.ui
    TriggerItemWidget.ui
    TriggerTableWidget.ui
    VariableAddDialog.ui
    VariableEditorWidget.ui
    VariablePropDialog.ui
    VariableItemWidget.ui
    ZombieItemWidget.ui
)

if(ECFLOW_QT5)
  QT5_WRAP_CPP(VIEWER_MOC ${viewer_moc_files} )
  QT5_ADD_RESOURCES (VIEWER_RES viewer.qrc)
  QT5_WRAP_UI       (VIEWER_FORMS_HEADERS ${viewer_wrap_ui_files})
else()
  QT4_WRAP_CPP(VIEWER_MOC ${viewer_moc_files} )
  QT4_ADD_RESOURCES (VIEWER_RES viewer.qrc)
  QT4_WRAP_UI       (VIEWER_FORMS_HEADERS ${viewer_wrap_ui_files})
endif()


# add all the images as dependencies of the resource file so that it is
# automatically recompiled when an image changes
file( GLOB image_files "${CMAKE_CURRENT_SOURCE_DIR}/../images/*.*" )
ADD_CUSTOM_TARGET(Qt_resource_cpp DEPENDS ${VIEWER_RES})
ADD_DEPENDENCIES(Qt_resource_cpp ${image_files})



add_definitions( -DECFLOW_SHARED_DIR="${CMAKE_INSTALL_PREFIX}/share/ecflow" )


ecbuild_add_executable( TARGET   ecflow_ui.x
    SOURCES  ${viewer_srcs} ${VIEWER_MOC} ${VIEWER_RES} ${VIEWER_FORMS_HEADERS}
    INCLUDES .
     ../../libViewer/src
     ../../../ACore/src
     ../../../ANattr/src
     ../../../ANode/src
     ../../../ANode/test

=== debian/changelog ===
ecflow (4.15.0-1) unstable; urgency=medium

  * Drop python2 support
  * New upstream release
  * Now use debhelper-compat (= 12)
  * Standards-Version: 4.4.0
  * Bypass dwz on this build: DIE missing
  * Add extra files pointed by dh_missing
  
 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Jul 2019 11:54:31 +0100

ecflow (4.14.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 27 Mar 2019 12:45:52 +0000

=== debian/control ===
Source: ecflow
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12), 
  dh-buildinfo,
  dh-python, 
  python3-dev,
  cmake (>= 3.12.0), 
  chrpath, 
  libmotif-dev, 
  libxpm-dev,
  libssl-dev,
  qtbase5-dev,
  libqt5gui5, 
  libqt5widgets5,
  libqt5core5a,
  libqt5network5,
  libqt5svg5-dev,
  libqt5charts5-dev,
  libboost-test-dev, 
  libboost-serialization-dev,
  libboost-date-time-dev, 
  libboost-thread-dev,
  libboost-regex-dev, libboost-python-dev, 
  libboost-program-options-dev, libboost-filesystem-dev
Standards-Version: 4.4.0
Homepage: https://software.ecmwf.int/wiki/display/ECFLOW/The+ECFLOW+Pre-processor
Vcs-Browser: https://salsa.debian.org:/science-team/ecflow.git
Vcs-Git: https://salsa.debian.org:/science-team/ecflow.git

Package: libecflow-view0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library for ecFlow worklow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 . 
 This package contains a shared library used by ecflow tools.

Package: ecflow-server
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}, ksh | mksh | pdksh | zsh
Description: Meteorological workflow controller - server 
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.


Package: ecflow-client
Architecture: any
Depends: libecflow-view0d ( = ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 ${python:Depends}, python-fuse
Description: Client tools for Meteorological workflow
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.
 .
 This package contains the client tools

Package: python3-ecflow
Section: python
Architecture: any
Depends: libecflow-view0d ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
 ${python3:Depends}, python3-fuse
Description: Python3 libraries for ecFlow workflow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 .
 This package contains Python3 modules used in writing ecflow scripts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@  --with python3 --with-buildsystem=cmake


DESTDIR:=`pwd`/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)

AUTOGENERATED:= ecflow-server.install ecflow-client.install libecflow-view0d.install
PY3VERSIONS:=$(shell py3versions -s)

FPIC:= 
ifeq ($(TARGET_ARCH), hppa)
	FPIC:= -fPIC
endif
ifeq ($(TARGET_ARCH), x32)
	FPIC:= -fPIC
endif
ifeq ($(TARGET_ARCH), i386)
	FPIC:= -fPIC
endif

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(FPIC) $(CPPFLAGS)  -DNO_REGEXP
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) $(FPIC)
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) $(FPIC) # -std=c++11

CMAKE_COMMON_FLAGS = \
                -DCMAKE_BUILD_TYPE=Release \
		-DDISABLE_OS_CHECK=ON \
		-DBOOST_INCLUDEDIR=/usr/include \
		-DBOOSTROOT=$(LIBDIR)	\
		-DENABLE_STATIC_BOOST_LIBS=OFF \
		-DENABLE_SSL=OFF \
		-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}"  

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(patsubst %, debian/%, ${AUTOGENERATED}) debian/build-*
	find . -name '*.pyc' -delete
	find . -name '*.job*' -delete

# For the moment set ENABLE_SSL=OFF. Enabling it fails tests

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	for p in ${PY3VERSIONS} ; do \
		PY3AB=`echo $$p | sed -e 's/python3\./python3/' `  ; \
		PY3VER=`echo $$p | sed -e 's/python//' `; \
		dh_auto_configure --builddirectory=debian/build-$$p -- \
			${CMAKE_COMMON_FLAGS} \
			-DPYTHON_MIN_VERSION=$$PY3VER \
			-DPYTHON_EXECUTABLE=$$p  \
			-DBoost_PYTHON_LIBRARY_RELEASE=$(LIBDIR)/libboost_$${PY3AB}.so ; \
		done

override_dh_auto_build:
	for p in ${PY3VERSIONS} ; do \
		dh_auto_build  --builddirectory=debian/build-$$p ; done

override_dh_auto_install:
	for p in ${PY3VERSIONS} ; do \
		dh_auto_install --builddirectory=debian/build-$$p ; \
		done
	#	Drop the suffixes on scripts ...
	mv $(DESTDIR)/usr/bin/ecflow_logserver.sh $(DESTDIR)/usr/bin/ecflow_logserver
	mv $(DESTDIR)/usr/bin/ecflow_start.sh 	$(DESTDIR)/usr/bin/ecflow_start
	mv $(DESTDIR)/usr/bin/ecflow_stop.sh 	$(DESTDIR)/usr/bin/ecflow_stop
	mv $(DESTDIR)/usr/bin/ecflow_test_ui.sh 	$(DESTDIR)/usr/bin/ecflow_test_ui
	mv $(DESTDIR)/usr/bin/ecflow_fuse.py	$(DESTDIR)/usr/bin/ecflow_fuse
	mv $(DESTDIR)/usr/bin/noconnect.sh	$(DESTDIR)/usr/bin/noconnect
	mv $(DESTDIR)/usr/bin/ecflow_logsvr.pl	$(DESTDIR)/usr/bin/ecflow_logsvr

override_dh_dwz:
	@echo "DWZ bypassed in this build"
